import _extends from 'babel-runtime/helpers/extends';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _get from 'babel-runtime/helpers/get';
import _inherits from 'babel-runtime/helpers/inherits';
import React from 'react';
import ReactDOM from 'react-dom';
import ReactSelect from 'react-select';

var Select = function (_ReactSelect) {
    _inherits(Select, _ReactSelect);

    function Select() {
        _classCallCheck(this, Select);

        return _possibleConstructorReturn(this, (Select.__proto__ || _Object$getPrototypeOf(Select)).apply(this, arguments));
    }

    _createClass(Select, [{
        key: 'renderOuter',
        value: function renderOuter(options, valueArray, focusedOption) {
            var _this2 = this;

            var dimensions = this.wrapper ? this.wrapper.getBoundingClientRect() : null;
            var menu = _get(Select.prototype.__proto__ || _Object$getPrototypeOf(Select.prototype), 'renderMenu', this).call(this, options, valueArray, focusedOption);

            if (!menu || !dimensions) return null;

            var maxHeight = document.body.offsetHeight - (dimensions.top + dimensions.height);
            return ReactDOM.createPortal(React.createElement(
                'div',
                {
                    ref: function ref(_ref2) {
                        _this2.menuContainer = _ref2;
                    },
                    className: 'Select-menu-outer',
                    onClick: function onClick(e) {
                        e.stopPropagation();
                    },
                    style: _extends({}, this.props.menuContainerStyle, {
                        zIndex: 9999,
                        position: 'absolute',
                        width: dimensions.width,
                        top: dimensions.top + dimensions.height,
                        left: dimensions.left,
                        maxHeight: Math.min(maxHeight, 200),
                        overflow: 'hidden'
                    })
                },
                React.createElement(
                    'div',
                    {
                        ref: function ref(_ref) {
                            _this2.menu = _ref;
                        },
                        role: 'listbox',
                        tabIndex: -1,
                        className: 'Select-menu',
                        id: this._instancePrefix + '-list',
                        style: _extends({}, this.props.menuStyle, {
                            maxHeight: Math.min(maxHeight, 200)
                        }),
                        onScroll: this.handleMenuScroll,
                        onMouseDown: this.handleMouseDownOnMenu
                    },
                    menu
                )
            ), document.body);
        }
    }]);

    return Select;
}(ReactSelect);

export default Select;