'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_ReactSelect) {
    _inherits(Select, _ReactSelect);

    function Select() {
        _classCallCheck(this, Select);

        return _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).apply(this, arguments));
    }

    _createClass(Select, [{
        key: 'renderOuter',
        value: function renderOuter(options, valueArray, focusedOption) {
            var _this2 = this;

            var dimensions = this.wrapper ? this.wrapper.getBoundingClientRect() : null;
            var menu = _get(Select.prototype.__proto__ || Object.getPrototypeOf(Select.prototype), 'renderMenu', this).call(this, options, valueArray, focusedOption);

            if (!menu || !dimensions) return null;

            var maxHeight = document.body.offsetHeight - (dimensions.top + dimensions.height);
            return _reactDom2.default.createPortal(_react2.default.createElement(
                'div',
                {
                    ref: function ref(_ref2) {
                        _this2.menuContainer = _ref2;
                    },
                    className: 'Select-menu-outer',
                    onClick: function onClick(e) {
                        e.stopPropagation();
                    },
                    style: _extends({}, this.props.menuContainerStyle, {
                        zIndex: 9999,
                        position: 'absolute',
                        width: dimensions.width,
                        top: dimensions.top + dimensions.height,
                        left: dimensions.left,
                        maxHeight: Math.min(maxHeight, 200),
                        overflow: 'hidden'
                    })
                },
                _react2.default.createElement(
                    'div',
                    {
                        ref: function ref(_ref) {
                            _this2.menu = _ref;
                        },
                        role: 'listbox',
                        tabIndex: -1,
                        className: 'Select-menu',
                        id: this._instancePrefix + '-list',
                        style: _extends({}, this.props.menuStyle, {
                            maxHeight: Math.min(maxHeight, 200)
                        }),
                        onScroll: this.handleMenuScroll,
                        onMouseDown: this.handleMouseDownOnMenu
                    },
                    menu
                )
            ), document.body);
        }
    }]);

    return Select;
}(_reactSelect2.default);

exports.default = Select;